//************************************************************************************
//**  
//**  File name:     D:\Projects\Base\Proteus\Chip_Emul.c
//**  Generated by:  Flowcode v3.3.5.45
//**  Date:          Wednesday, December 23, 2009 19:29:36
//**  Licence:       
//**  Registered to: as
//**  
//**  
//**       USSR
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//  
#define MX_AVR
#define MX_TINY
#define MX_EE
#define MX_EE_SIZE 128
#define MX_USI
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 5
#define MX_SPI_SDO 6
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UCSRC
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_B
#define MX_I2C_SDA 5
#define MX_I2C_SCL 7
#define MX_PWM
#define MX_PWM_PORT PORTB
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRB
#define MX_PWM_1 3
#define MX_PWM_TRIS2 DDRB
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//
#define F_CPU 4000000UL
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

// 
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff
#pragma DATA 0x2, 0xff

// 
#include "C:\Program Files\Matrix Multimedia\Flowcode_AVR\FCD\internals.h"

//  
char FCM_RD(char FCL_NUM_BIT);
void FCM_Test_Null(char FCL_EE);
char FCM_Swap(char FCL_DATA);


// 
volatile char FCV_TST;
volatile char FCV_DATA_BYTE;
volatile char FCV_RD_WR;
volatile char FCV_X;
volatile char FCV_TX;
volatile char FCV_ADRESS;
volatile char FCV_DATA_SWAP;
volatile char FCV_CLK;

char FCLV_LOOP1;
char FCLV_LOOP2;
char FCLV_LOOP3;



//EEPROM0: //  

static char FCD_EEPROM0_EEPROMRead(short addr);
static void FCD_EEPROM0_WriteEEPROM(short addr, char data);


//LEDs0: //  

static void FCD_LEDs0_LEDOn(char WhichLED);
static void FCD_LEDs0_LEDOff(char WhichLED);

// 


// 

char FCM_RD(char FCL_NUM_BIT)
{
	
	//  
	char FCL_WR;
	char FCL_CLK;
	char FCL_DATA_IN;
	char FCL_DATA;

	char FCR_RETVAL;

	//- 
	//: While RD.Num_Bit > 0
	while(1)
	{
		// 
		//:
		//  RD.Return = RD.Return >> 1
		FCR_RETVAL =  FCR_RETVAL >> 1 ;
		

		//  
		//: While RD.CLK = 0
		while(1)
		{
			// 
			//: B1 -> RD.CLK
			DDRB = DDRB & 0xfd;
			FCL_CLK = ((PINB & 0x02) == 0x02);


			if (( FCL_CLK == 0 ) == 0) break;
		}


		// 
		//: B0 -> RD.DATA_IN
		DDRB = DDRB & 0xfe;
		FCL_DATA_IN = ((PINB & 0x01) == 0x01);


		//
		//: RD.DATA_IN = 1?
		if( FCL_DATA_IN == 1 )
		{
			//
			//:
			//  RD.Return = RD.Return OR 0x80
			FCR_RETVAL =  FCR_RETVAL | 0x80 ;
			

		}


		//  
		//: While RD.CLK = 1
		while(1)
		{
			// 
			//: B1 -> RD.CLK
			DDRB = DDRB & 0xfd;
			FCL_CLK = ((PINB & 0x02) == 0x02);


			if (( FCL_CLK == 1 ) == 0) break;
		}


		//
		//:
		//  RD.Num_Bit = RD.Num_Bit - 1
		FCL_NUM_BIT =  FCL_NUM_BIT - 1 ;
		

		if (( FCL_NUM_BIT > 0 ) == 0) break;
	}


	return (FCR_RETVAL);
}

void FCM_Test_Null(char FCL_EE)
{
	
	//  
	// : Test_Null.EE=EEPROM(0)::Read(X)
	FCL_EE = FCD_EEPROM0_EEPROMRead(FCV_X);


	// ?
	//: Test_Null.EE > 85?
	if( FCL_EE > 85 )
	{
		//?
		//: X >= 32?
		if( FCV_X >= 32 )
		{
			//    3 
			//:  3 
			for (FCLV_LOOP2=0; FCLV_LOOP2<3; FCLV_LOOP2++)
			{
				// 
				// : EEPROM(0)::Write(X, 0)
				FCD_EEPROM0_WriteEEPROM(FCV_X, 0);


			}


		} else {
			//    8 
			//:  8 
			for (FCLV_LOOP3=0; FCLV_LOOP3<8; FCLV_LOOP3++)
			{
				// 
				// : EEPROM(0)::Write(X, 0)
				FCD_EEPROM0_WriteEEPROM(FCV_X, 0);


			}


		}


	}


}

char FCM_Swap(char FCL_DATA)
{
	
	//  
	char FCL_HI;
	char FCL_LOW;

	char FCR_RETVAL;

	//
	//:
	//  Swap.Low = Swap.Data >> 4
	//  Swap.Hi = Swap.Data << 4
	//  Swap.Return = Swap.Hi OR Swap.Low
	FCL_LOW =  FCL_DATA >> 4 ;
	FCL_HI =  FCL_DATA << 4 ;
	FCR_RETVAL =  FCL_HI | FCL_LOW ;
	

	return (FCR_RETVAL);
}



//EEPROM0: // 


static char FCD_EEPROM0_EEPROMRead(short addr)
{
	  char data = 0;

	  #ifdef MX_EE

		#ifdef EEWE
			while (test_bit(EECR, EEWE));
		#else
			while (test_bit(EECR, EEPE));
		#endif

		data = eeprom_read_byte((unsigned char *)addr);
	  #else
	    #pragma error "Chip does not have EEPROM memory"
	  #endif

	  return (data);


}

static void FCD_EEPROM0_WriteEEPROM(short addr, char data)
{
	
	  #ifdef MX_EE

		#ifdef EEWE
			while (test_bit(EECR, EEWE));
		#else
			while (test_bit(EECR, EEPE));
		#endif

		cli();
		eeprom_write_byte((unsigned char *)addr, data);
		sei();
	  #else
		#pragma error Chip does not have EEPROM memory
	  #endif

}



//LEDs0: // 


static void FCD_LEDs0_LEDOn(char WhichLED)
{
	
		char LEDMask = 0;
		switch (WhichLED)
		{
			case 0:
				LEDMask = 1;
				break;
		  #if (4 > 1)
			case 1:
				LEDMask = 2;
				break;
		  #endif
		  #if (4 > 2)
			case 2:
				LEDMask = 4;
				break;
		  #endif
		  #if (4 > 3)
			case 3:
				LEDMask = 8;
				break;
		  #endif
		  #if (4 > 4)
			case 4:
				LEDMask = 0;
				break;
		  #endif
		  #if (4 > 5)
			case 5:
				LEDMask = 0;
				break;
		  #endif
		  #if (4 > 6)
			case 6:
				LEDMask = 0;
				break;
		  #endif
		  #if (4 > 7)
			case 7:
				LEDMask = 0;
				break;
		  #endif
		}

	  #define LED_portd

	  #ifdef LED_porta
		DDRA |= LEDMask;
		PORTA |= LEDMask;
	  #endif
	  #ifdef LED_portb
		DDRB |= LEDMask;
		PORTB |= LEDMask;
	  #endif
	  #ifdef LED_portc
		DDRC |= LEDMask;
		PORTC |= LEDMask;
	  #endif
	  #ifdef LED_portd
		DDRD |= LEDMask;
		PORTD |= LEDMask;
	  #endif
	  #ifdef LED_porte
		DDRE |= LEDMask;
		PORTE |= LEDMask;
	  #endif
	  #ifdef LED_portf
		DDRF |= LEDMask;
		PORTF |= LEDMask;
	  #endif
	  #ifdef LED_portg
		DDRG |= LEDMask;
		PORTG |= LEDMask;
	  #endif
	  #ifdef LED_porth
		DDRH |= LEDMask;
		PORTH |= LEDMask;
	  #endif
	  #ifdef LED_porti
		DDRI |= LEDMask;
		PORTI |= LEDMask;
	  #endif
	  #ifdef LED_portj
		DDRJ |= LEDMask;
		PORTJ |= LEDMask;
	  #endif
	  #ifdef LED_portk
		DDRK |= LEDMask;
		PORTK |= LEDMask;
	  #endif

	  #undef LED_portd

}

static void FCD_LEDs0_LEDOff(char WhichLED)
{
		char LEDMask = 0;
		switch (WhichLED)
		{
			case 0:
				LEDMask = 1;
				break;
		  #if (4 > 1)
			case 1:
				LEDMask = 2;
				break;
		  #endif
		  #if (4 > 2)
			case 2:
				LEDMask = 4;
				break;
		  #endif
		  #if (4 > 3)
			case 3:
				LEDMask = 8;
				break;
		  #endif
		  #if (4 > 4)
			case 4:
				LEDMask = 0;
				break;
		  #endif
		  #if (4 > 5)
			case 5:
				LEDMask = 0;
				break;
		  #endif
		  #if (4 > 6)
			case 6:
				LEDMask = 0;
				break;
		  #endif
		  #if (4 > 7)
			case 7:
				LEDMask = 0;
				break;
		  #endif
		}

	  #define LED_portd

	  #ifdef LED_porta
		DDRA |= LEDMask;
		PORTA &= ~LEDMask;
	  #endif
	  #ifdef LED_portb
		DDRB |= LEDMask;
		PORTB &= ~LEDMask;
	  #endif
	  #ifdef LED_portc
		DDRC |= LEDMask;
		PORTC &= ~LEDMask;
	  #endif
	  #ifdef LED_portd
		DDRD |= LEDMask;
		PORTD &= ~LEDMask;
	  #endif
	  #ifdef LED_porte
		DDRE |= LEDMask;
		PORTE &= ~LEDMask;
	  #endif
	  #ifdef LED_portf
		DDRF |= LEDMask;
		PORTF &= ~LEDMask;
	  #endif
	  #ifdef LED_portg
		DDRG |= LEDMask;
		PORTG &= ~LEDMask;
	  #endif
	  #ifdef LED_porth
		DDRH |= LEDMask;
		PORTH &= ~LEDMask;
	  #endif
	  #ifdef LED_porti
		DDRI |= LEDMask;
		PORTI &= ~LEDMask;
	  #endif
	  #ifdef LED_portj
		DDRJ |= LEDMask;
		PORTJ &= ~LEDMask;
	  #endif
	  #ifdef LED_portk
		DDRK |= LEDMask;
		PORTK &= ~LEDMask;
	  #endif

	  #undef LED_portd

}

// 


int main()
{
	
	//
	MCUCR=0x0a;


	//  
	GIMSK=0x00;


	//Call Macro
	//: Adress=RD(3)
	FCV_ADRESS = FCM_RD(3);


	//
	//:
	//  Adress = Adress >> 5
	FCV_ADRESS =  FCV_ADRESS >> 5 ;
	

	//
	//: Adress > 1?
	if( FCV_ADRESS > 1 )
	{
		// 
		// : LEDs(0)::LED-(1)
		FCD_LEDs0_LEDOn(1);


		//   
		//:
		//  X = 32
		FCV_X =  32 ;
		

		//  
		//: Test_Null(X)
		FCM_Test_Null(FCV_X);


		//   
		//:
		//  X = X + 1
		FCV_X =  FCV_X + 1 ;
		

		//  
		//: Test_Null(X)
		FCM_Test_Null(FCV_X);


		//   
		//:
		//  X = X + 1
		FCV_X =  FCV_X + 1 ;
		

		//  
		//: Test_Null(X)
		FCM_Test_Null(FCV_X);


		//   
		//:
		//  X = 32
		FCV_X =  32 ;
		

	} else {
		// 
		// : LEDs(0)::LED-(0)
		FCD_LEDs0_LEDOn(0);


		//   
		//:
		//  X = 0
		FCV_X =  0 ;
		

		//  
		//: Test_Null(X)
		FCM_Test_Null(FCV_X);


	}


	//:
	//


	//
	//: Rd_Wr=RD(1)
	FCV_RD_WR = FCM_RD(1);


	//  ?
	//: Rd_Wr = 128?
	if( FCV_RD_WR == 128 )
	{
		// 
		// : LEDs(0)::LED-(2)
		FCD_LEDs0_LEDOn(2);


		//     
		//: While X<64
		while( FCV_X < 64 )
		{
			//  
			//: Data_Byte=RD(8)
			FCV_DATA_BYTE = FCM_RD(8);


			// 
			//: Data_Swap=Swap(Data_Byte)
			FCV_DATA_SWAP = FCM_Swap(FCV_DATA_BYTE);


			//  
			// : EEPROM(0)::Write(X, Data_Swap)
			FCD_EEPROM0_WriteEEPROM(FCV_X, FCV_DATA_SWAP);


			// 
			//:
			//  X = X + 1
			FCV_X =  FCV_X + 1 ;
			

		}


	} else {
		// 
		// : LEDs(0)::LED-(3)
		FCD_LEDs0_LEDOn(3);


		//  
		//: While X<64
		while( FCV_X < 64 )
		{
			// 
			// : Data_Byte=EEPROM(0)::Read(X)
			FCV_DATA_BYTE = FCD_EEPROM0_EEPROMRead(FCV_X);


			// 
			//:
			//  X = X + 1
			FCV_X =  FCV_X + 1 ;
			

			// 
			//: Data_Swap=Swap(Data_Byte)
			FCV_DATA_SWAP = FCM_Swap(FCV_DATA_BYTE);


			// 8  
			//:  8 
			for (FCLV_LOOP1=0; FCLV_LOOP1<8; FCLV_LOOP1++)
			{
				//
				//:
				//  TX = Data_Swap AND 1
				FCV_TX =  FCV_DATA_SWAP & 1 ;
				

				//
				//: TX -> B0
				DDRB = DDRB | 0x01;
				if (FCV_TX)
					PORTB = (PORTB & 0xfe) | 0x01;
				else
					PORTB = PORTB & 0xfe;


				//
				//:
				//  Data_Swap = Data_Swap >> 1
				FCV_DATA_SWAP =  FCV_DATA_SWAP >> 1 ;
				

				//  
				//: While CLK= 0
				while(1)
				{
					// 
					//: B1 -> CLK
					DDRB = DDRB & 0xfd;
					FCV_CLK = ((PINB & 0x02) == 0x02);


					if (( FCV_CLK == 0 ) == 0) break;
				}


				//  
				//: While CLK= 1
				while(1)
				{
					// 
					//: B1 -> CLK
					DDRB = DDRB & 0xfd;
					FCV_CLK = ((PINB & 0x02) == 0x02);


					if (( FCV_CLK == 1 ) == 0) break;
				}


			}


		}


	}


	//
	//: While 1
	while( 1 )
	{
	}


	mainendloop: goto mainendloop;
}



